<template>
  <section>
    <div>
      <p>Gere um código de 6 digitos pra validar o formulário</p>
      <div class="grid-2-desktop">
        <div>
          <h2 class="current-code">Código Atual</h2>
          <div class="border-code current">
            <p class="current-code">
              {{ currentCode }}
            </p>
          </div>
        </div>
        <div>
          <h2 class="old-code">Código Anterior</h2>
          <div class="border-code old-code-border">
            <p class="old-code">
              {{ oldCode }}
            </p>
          </div>
        </div>
      </div>
      <button class="btn-code" v-on:click="generateOTP()">Gerar código</button>
      <p>
        Obs: Utilize também o código anteriar para que o erro seja retornado.
      </p>
    </div>
    <div class="box-login">
      <form class="form-control-recovery__content" v-if="!succesAnimation && !errorAnimation">
        <p>Agora digite o código de 6 digitos enviado para o e-mail</p>
        <div
          v-on:click="clickPaste()"
          v-if="messagePasteCode"
          class="message-paste"
        >
          <p>Vimos que você copiou um código.</p>
          <p>Clique aqui para colar</p>
        </div>
        <div class="form-control-recovery">
          <input
            v-for="(code, index) in codeRecoveryNumber"
            :key="`code-recovery-input-${code}`"
            :maxlength="max"
            v-bind:class="[
              correctNumber ? 'successInput' : '',
              errorNumber ? 'warnInput' : '',
              'form-control-recovery__content-input',
            ]"
            type="text"
            v-model="code.inputCode"
            ref="codeRecoveryNumber"
            @focus="readClipBoard()"
            @paste="pasteCode($event)"
            @keypress="inputKeysAllowed($event, index)"
            @keyup.delete="handleInput($event, index)"
            @click="selectInput($event, index)"
            @input="moveToNextField($event, $event.target.value, index)"
          />
        </div>
      </form>
      <div v-if="succesAnimation">
        <LoaderSuccessWarn :success="true" />
      </div>
      <div v-if="errorAnimation">
        <LoaderSuccessWarn :success="false" />
      </div>
    </div>
  </section>
</template>
 
 <script>
import LoaderSuccessWarn from "./components/LoaderSuccessWarn.vue";
export default {
  name: "App",
  data() {
    return {
      succesAnimation: false,
      errorAnimation: false,
      genericNumber: "",
      currentCode: "",
      oldCode: "",
      formForgot: {
        userID: 0,
        username: "",
        maskedEmail: "",
        phoneLastNumbers: "",
        socialLogins: "",
        deliveryChannel: "",
        receivedCode: "",
        tokenCode: "",
      },
      errorsForgot: [],
      max: 1,
      codeRecoveryNumber: [
        { inputCode: "" },
        { inputCode: "" },
        { inputCode: "" },
        { inputCode: "" },
        { inputCode: "" },
        { inputCode: "" },
      ],
      loadedCode: false,
      errorNumber: false,
      correctNumber: false,
      errorsForgotCode: [],
      textclip: "",
      messagePasteCode: false,
    };
  },
  components: {
    LoaderSuccessWarn,
  },
  watch: {
    codeRecoveryNumber: {
      handler() {
        this.stringCode();
      },
      deep: true,
    },
    genericNumber: {
      handler(val, oldVal) {
        this.currentCode = val;
        this.oldCode = oldVal;
      },
      deep: true,
    },
  },
  methods: {
    async readClipBoard() {
      try {
        let iOS =
          !window.MSStream && /iPad|iPhone|iPod/.test(navigator.userAgent);
        if (!iOS) {
          const text = await navigator.clipboard.readText();
          const regex = /[0-9]/;
          regex.test(text);

          if (regex.test(text) && text.length === 6) {
            this.messagePasteCode = true;
          }
          if (this.$refs.codeRecoveryNumber[0].value.length > 0) {
            this.messagePasteCode = false;
          }
        }
      } catch (error) {
        console.error(error);
      }
    },
    async clickPaste() {
      try {
        const text = await navigator.clipboard.readText();
        const separateValues = text.split("", 6);

        for (let i = 0, l = this.codeRecoveryNumber.length; i < l; i++) {
          const form = this.codeRecoveryNumber[i];
          form.inputCode = separateValues[i];
        }
        this.messagePasteCode = false;
      } catch (error) {
        console.error(error);
      }
    },
    async pasteCode() {
      try {
        const text = await navigator.clipboard.readText();
        const regex = /[0-9]/;
        regex.test(text);
        if (regex.test(text)) {
          const separateValues = text.split("", 6);

          for (let i = 0, l = this.codeRecoveryNumber.length; i < l; i++) {
            const form = this.codeRecoveryNumber[i];
            form.inputCode = separateValues[i];
          }

          this.messagePasteCode = false;
          this.$refs.codeRecoveryNumber[5].focus();
          this.$refs.codeRecoveryNumber[5].select();
        }
      } catch (error) {
        console.error(error);
      }
    },
    stringCode() {
      let code = "";
      for (let i = 0; i < this.codeRecoveryNumber.length; i++) {
        const form = this.codeRecoveryNumber[i];
        code = code + form.inputCode;
      }
      this.formForgot.receivedCode = code;
      if (
        code.length === 6 &&
        this.formForgot.receivedCode === this.genericNumber
      ) {
        this.correctNumber = !this.correctNumber;
        setTimeout(() => (this.succesAnimation = true), 400);

        

      }
      if (
        code.length === 6 &&
        this.formForgot.receivedCode != this.genericNumber
      ) {
        this.errorNumber = true;
        setTimeout(() => (this.errorAnimation = true), 400);
      }
    },
    restartTimer() {
      this.timeElapsed = 0;
      this.timerInterval = undefined;
      this.timeLimit = 40;
      this.startTimer();
    },
    startTimer() {
      this.timerInterval = setInterval(() => {
        if (++this.timeElapsed === this.timeLimit) {
          clearInterval(this.timerInterval);
        }
        if (this.timeLimit - this.timeElapsed == 0) {
          this.endTime = !this.endTime;
        }
      }, 1000);
    },
    selectInput(e, index) {
      this.$refs.codeRecoveryNumber[index].select();
      this.$refs.codeRecoveryNumber[index].focus();
      this.errorNumber = false;
    },
    moveToNextField(e, value, index) {
      const nextIndex = index + 1;
      if (nextIndex < this.codeRecoveryNumber.length && value.length > 0) {
        this.$refs.codeRecoveryNumber[nextIndex].select();
        this.$refs.codeRecoveryNumber[nextIndex].focus();
      }
    },
    inputKeysAllowed(evt) {
      evt = evt || window.event;
      const charCode = evt.which ? evt.which : evt.keyCode;
      if (
        charCode > 31 &&
        (charCode < 48 || charCode > 57) &&
        charCode !== 46
      ) {
        evt.preventDefault();
      }
      return true;
    },
    handleInput(e, index) {
      const currentIndex = index;
      const previousIndex = index - 1;
      const hasPreviousIndex = previousIndex >= 0;
      if (!e.target.value.length && hasPreviousIndex) {
        this.$refs.codeRecoveryNumber[currentIndex].value = null;
        this.$refs.codeRecoveryNumber[previousIndex].focus();
        this.$refs.codeRecoveryNumber[previousIndex].select();
        this.errorNumber = false;
        this.correctNumber = false;
      }
      if (index === 0) {
        this.$refs.codeRecoveryNumber[currentIndex].value = null;
      }
      return e.preventDefault();
    },
    generateOTP() {
      let OTP = "";
      for (let i = 0; i < 6; i++) {
        OTP += Math.floor(Math.random() * 10);
        this.genericNumber = OTP;
      }
      this.errorNumber = false;
      this.correctNumber = false;
      this.errorAnimation = false
      this.succesAnimation = false
      for (let i = 0, l = this.codeRecoveryNumber.length; i < l; i++) {
          const form = this.codeRecoveryNumber[i];
          form.inputCode = ''[i];
        }
 
      return OTP;
    },
  },
};
</script>
 
 <style lang="scss" >
@import url("https://fonts.googleapis.com/css2?family=Nunito&display=swap");

body {
  font-family: "Nunito";
  width: 100%;
  margin: 0;
  padding: 0;
  background: #fdfcfc;
}
section {
  padding: 40px 0;
  margin: auto;
  max-width: 450px;
  width: 100%;
}
.current-code {
  color: green;
}
.old-code {
  color: red;
}
#app {
  font-family: "Nunito", sans-serif;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  text-align: center;
  color: #2c3e50;
  margin-top: 60px;
}
.grid-2-desktop {
  display: grid;
  grid-template-columns: 1fr 1fr;
  gap: 20px;
  h2 {
    font-size: 16px;
    font-weight: 600;
  }
  p {
    font-size: 22px;
    font-weight: 800;
  }
}
.btn-code {
  background: rgb(233, 233, 248);
  border: 1px solid rgb(118, 118, 248);
  padding: 10px;
  width: 100%;
  border-radius: 10px;
}
.border-code {
  border: 2px solid #313131;
  border-radius: 10px;
  margin-bottom: 20px;
  min-height: 76px;
  height: auto;
  &.current {
    border: 2px solid green;
  }
  &.old-code-border {
    border: 2px solid red;
  }
}
.box-login {
  max-width: 350px;
  padding: 10%;
  margin: auto;
  background: #fff;
  box-shadow: 0 0 10px 1px rgb(0 0 0 / 12%);
  border-radius: 20px;

  @media (max-width: 600px) {
    margin: auto;
    padding: 5%;
  }
}
.message-paste {
  position: absolute;
  background: #394fef;
  border-radius: 10px;
  padding: 10px;
  margin-top: -60px;
  box-shadow: 0 0 10px 1px rgb(0 0 0 / 12%);
  cursor: pointer;

  p {
    line-height: 16px;
    padding: 0;
    margin: 0;
    color: #fff;
  }

  &::before {
    content: "";
    position: absolute;
    width: 0;
    height: 0;
    bottom: -10px;
    rotate: 180deg;
    left: 0.5em;
    border: 0.75rem solid transparent;
    border-top: none;
    border-bottom-color: #394fef;
    filter: drop-shadow(0 -0.0625rem 0.0625rem rgb(0 0 0 / 10%));
  }
}
.form-control-recovery {
  display: flex;
  align-items: center;
  justify-content: space-between;

  h1 {
    margin-bottom: 0;
    font-size: 2rem;
    font-weight: 200;
  }

  .form-control-recovery__content {
    margin: 3rem 0;
    border-radius: 0.5rem;
    background: #fff;
    box-shadow: 28px 28px 56px #d9d9d9, -28px -28px 56px #fff;
  }

  .form-control-recovery__content-input {
    width: 30px;
    height: 40px;
    appearance: none;
    background-image: none;
    outline: none;
    line-height: 1em;
    border-radius: 9px;
    border: 1px solid #eaeaea;
    padding: 0 10px;
    font-size: 1em;
    background-color: #fff;
    vertical-align: middle;
    text-align: center;

    &:focus {
      border: 2px solid #394fef;
    }

    &.warnInput {
      border: 2px solid red;
      animation: shake 0.2s 2;

      @keyframes shake {
        25% {
          translate: 6px 0;
        }

        50% {
          translate: 6px 0;
        }

        75% {
          translate: 6px 0;
        }
      }
    }

    &.successInput {
      border: 2px solid #4ed887;
    }
  }
  /* Chrome, Safari, Edge, Opera */
  input::-webkit-outer-spin-button,
  input::-webkit-inner-spin-button {
    appearance: none;
    margin: 0;
  }

  /* Firefox */
  input[type="number"] {
    appearance: textfield;
  }
  input::selection {
    background: rgb(255 255 255 / 0%);
  }
}

.form-control input:read-only {
  background: #f5f5f5;
  color: #383b41;
  opacity: 1;
  cursor: not-allowed;
}
</style>
 